import java.io.*;

import dk.vajhoej.record.*;
import dk.vajhoej.isam.*;
import dk.vajhoej.isam.cache.*;
import dk.vajhoej.isam.local.*;
import dk.vajhoej.isam.remote.*;

public class Test5 {
    public static void list(IsamSource isam) throws IsamException, RecordException {
        IsamResult<Data5> res = isam.readGT(Data5.class, new Key<Integer>(0, 0));
        while(res.read()) {
            Data5 o = res.current();
            System.out.println(o.getId() + " " + o.getClass().getName() + " " + o);
        }
        res.close();
    }
    public static void test(IsamSource isam) throws IsamException, RecordException {
        list(isam);
    }
    public static void main(String[] args) {
        try {
            System.out.println("**** struct with struct field and variable length ****");
            System.out.println("local");
            System.out.println("=====");
            IsamSource local = new LocalIsamSource("data5.isq", "dk.vajhoej.vms.rms.IndexSequential", false);
            test(local);
            local.close();
            if(args.length > 0 && args[0].toLowerCase().equals("noremote")) System.exit(0);
            System.out.print("Start server and press return...");
            System.in.read();
            System.out.println("remote");
            System.out.println("======");
            IsamSource remote = new RemoteIsamSource("localhost", 10005);
            test(remote);
            remote.close();
        } catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}
